#include <windows.h>
#include <windowsx.h>
//#include <shlwapi.h>
//#include <commctrl.h>
//#include <comdlg32.h>
//#include <comctl32.h>
//#include <sys\stat.h>
//#include <stdio.h>
#define elemof(x) (sizeof(x)/sizeof(*(x)))

static void PaintColorButton(DRAWITEMSTRUCT*dis, COLORREF bkcolor){
 TCHAR text[32];
 GetWindowText(dis->hwndItem,text,elemof(text));
 SetTextColor(dis->hDC,0);
 SetBkColor(dis->hDC,bkcolor);
 ExtTextOut(dis->hDC,0,0,ETO_OPAQUE,&dis->rcItem,0,0,0);	// Rechteck mit Hintergrundfarbe fllen
// TODO: Das Zeichnen des Unterstrichs erst beim Drcken von ALT nachbilden!
// Macht gegenber WM_CTLCOLOR viel zuviel Arbeit!
// Zudem fehlt das Fokusrechteck.
 DrawText(dis->hDC,text,-1,&dis->rcItem,DT_CENTER|DT_SINGLELINE|DT_VCENTER);
 DrawEdge(dis->hDC, &dis->rcItem, dis->itemState & ODS_SELECTED ? EDGE_SUNKEN : EDGE_RAISED, BF_RECT);
}

// unsauber: Font wird beim Schlieen des Dialogs nicht gelscht.
// Auf Dauer fatal unter Win16.
// Richtige aber zu umstndliche Lsung: Fenster subklassifizieren und WM_NCDESTROY abfangen.
// Zweckmige Lsung: Font im Dialog (Elternfenster) vorhalten.
// Brauchbare, langsame Lsung: Font bei PaintColorButton() erzeugen und lschen. Oder bei WM_CTLCOLOR.
static void SetFontHeight(HWND hWnd, int h /*in typografischen Punkt*/) {
 LOGFONT lf;
 GetObject(GetWindowFont(hWnd),sizeof lf,&lf);
 HDC dc=GetDC(hWnd);
 lf.lfHeight = -MulDiv(h,GetDeviceCaps(dc,LOGPIXELSY),72);	// new height
 ReleaseDC(hWnd,dc);
 lf.lfWidth = 0;	// auto-detect
// lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;	// sonst ist's pixelig
 lstrcpyn(lf.lfFaceName,"Arial",elemof(lf.lfFaceName));	// sonst ist's pixelig
 SetWindowFont(hWnd,CreateFontIndirect(&lf),TRUE);
}

HINSTANCE ghInstance;

INT_PTR CALLBACK MainDlgProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam) {
 switch (Msg){
  case WM_INITDIALOG: {
            //Icon laden
			HICON ico=LoadIcon(ghInstance,MAKEINTRESOURCE(100));		
			SetClassLongPtr(hWnd,GCLP_HICON,(LONG_PTR)ico);		
			SetClassLongPtr(hWnd,GCLP_HICONSM,(LONG_PTR)ico);	
        	//BUTTON size
			SetFontHeight(GetDlgItem(hWnd,200),32);
		}return TRUE;

        case WM_DRAWITEM:  {
	 DRAWITEMSTRUCT*dis = (DRAWITEMSTRUCT*)lParam;
	 switch (LOBYTE(wParam)) {  
          case 200: PaintColorButton(dis,RGB(255,200,100)); break;
	 }
        }break;

        case WM_COMMAND: switch(LOBYTE(wParam)){
		case IDOK:
		case IDCANCEL:{
			EndDialog(hWnd,0);
		}break;

		case 200: {
			MessageBox(hWnd, "Danke!", "Farben", MB_OK | MB_ICONINFORMATION);
                }break;
        }break; 
/*
        case WM_SYSCOMMAND: switch (wParam&0xFFF0) {
			case SC_CLOSE: {
   				
				//Nicht fr Dialoge! SendMessage(hWnd,WM_ENDSESSION,TRUE,0);
				EndDialog(hWnd,0);
			}break;
		}break;
*/
 }
 return 0;
}


/******************************
 * main program (entry point) *
 ******************************/
__declspec(noreturn) void WinMainCRTStartup(void) { 
 ghInstance=GetModuleHandle(0);
 ExitProcess((UINT)DialogBox(0,MAKEINTRESOURCE(100),0,MainDlgProc));
}
